"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Heartbeat = void 0;
const logger_1 = require("../../../util/logger");
const path_1 = __importDefault(require("path"));
const thread_helper_1 = require("../../../util/thread-helper");
class Heartbeat {
    constructor(client, workerId) {
        this.config = client.config;
        this.client = client.client;
        this.workerId = workerId;
        this.logger = new logger_1.Logger(`HeartbeatController`, this.config.log_level);
    }
    start() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.heartbeatWorker) {
                this.heartbeatWorker = (0, thread_helper_1.runThreaded)(path_1.default.join(__dirname, './heartbeat-worker'), {
                    workerData: {
                        config: this.config,
                        workerId: this.workerId,
                    },
                });
            }
        });
    }
    stop() {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            (_a = this.heartbeatWorker) === null || _a === void 0 ? void 0 : _a.postMessage('stop');
            (_b = this.heartbeatWorker) === null || _b === void 0 ? void 0 : _b.terminate();
            this.heartbeatWorker = undefined;
        });
    }
}
exports.Heartbeat = Heartbeat;
