import { Channel, ClientFactory } from 'nice-grpc';
import { EventsServiceClient } from '../../protoc/events/events';
import { ClientConfig } from '../hatchet-client/client-config';
import { Logger } from '../../util/logger';
export declare enum LogLevel {
    INFO = "INFO",
    WARN = "WARN",
    ERROR = "ERROR",
    DEBUG = "DEBUG"
}
export interface PushEventOptions {
    additionalMetadata?: Record<string, string>;
}
export declare class EventClient {
    config: ClientConfig;
    client: EventsServiceClient;
    logger: Logger;
    constructor(config: ClientConfig, channel: Channel, factory: ClientFactory);
    push<T>(type: string, input: T, options?: PushEventOptions): Promise<import("../../protoc/events/events").Event>;
    putLog(stepRunId: string, log: string, level?: LogLevel): void;
    putStream(stepRunId: string, data: string | Uint8Array): void;
}
